UNIT mChatServer;
{**************************************************************************
  mChatServer.pas

  Die eigentliche Klasse ChatServer.

  Diese Datei gehrt zu den Materialien zu dem Workshop
  "Zentralabitur: Kommunikation in Netzwerken" des 5. Informatiktag
  in Paderborn.
  Dieses Projekt ist im Frhjahr 2006 im Unterricht meines GK Informatik
  Jgst. 12 entwickelt und fr den Workshop nur leicht berarbeitet worden.
  Sie darf fr eigene Unterrichtszwecke frei verwendet werden.
  Eine anderweitige Verffentlichung ist nur mit meiner Erlaubnis zulssig.

  (c) Joachim Deckers, <joachim@deckers.name>, 03.04.2006
***************************************************************************}

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses mServer, mSuM, mZeilenbereich, mTextwerkzeug, mUser;

const
  MAXUSER = 100;
type
  ChatServer = class(Server)


  private //Attribute
    hatTextwerkzeug : Textwerkzeug;
    Userfeld : array [1..MAXUSER] of user;
    zAnzUser : GanzeZahl;

  public //Methoden
    constructor init (pPortNr: GanzeZahl); overload;
    procedure bearbeiteNachricht (pClientIP: Zeichenkette; pClientPort: GanzeZahl; pNachricht: Zeichenkette); override;
    procedure bearbeiteVerbindungsende (pClientIP: Zeichenkette; pClientPort: GanzeZahl); override;
    procedure bearbeiteVerbindungsverlust (pClientIP: Zeichenkette; pClientPort: GanzeZahl); override;
    procedure bearbeiteVerbindungsaufbau (pClientIP: Zeichenkette; pClientPort: GanzeZahl); override;
    procedure loescheUser(pClientIP: Zeichenkette; pClientPort: GanzeZahl); virtual;
    function sucheIpPort(pClientIp: Zeichenkette; pClientPort: GanzeZahl):GanzeZahl; virtual;
    function sucheUsername (pUsername : Zeichenkette):Wahrheitswert;virtual;
   end;

implementation

//+---------------------------------------------------------------------
//|         ChatServer: Methodendefinition
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor ChatServer.init (pPortNr: GanzeZahl);
var i : GanzeZahl;
begin
  inherited init(pPortNr, FALSCH);
  hatTextwerkzeug := Textwerkzeug.init;
  zAnzUser := 0;
  for i:=1 to MAXUSER do
    userfeld[i] := nil;
end;

//-------- bearbeiteNachricht (public) ---------------------------------
procedure ChatServer.bearbeiteNachricht (pClientIP: Zeichenkette; pClientPort: GanzeZahl; pNachricht: Zeichenkette);
var
  i,lIndex : GanzeZahl;
  lUserliste,
  lAbsender,
  lEmpfaenger : Zeichenkette;
begin
   // Zeilenendezeichen entfernen
   lIndex:=hatTextwerkzeug.positionVon(pNachricht,#13);
   if lIndex>0 then
     pNachricht:=hatTextwerkzeug.teilZeichenkette(pNachricht,1,lIndex-1);

   // Nachricht auswerten  
   lIndex:=self.sucheIpPort(pClientIp,pClientPort);
   if (lIndex=0) then
   begin
     if hatTextwerkzeug.teilZeichenkette(pNachricht, 1,5)= 'USER ' then
       begin
         if (not self.sucheUsername(hatTextwerkzeug.textOhne(pNachricht,1,5))) and (zAnzUser<MAXUSER) and (hatTextwerkzeug.positionVon(hatTextwerkzeug.textOhne(pNachricht,1,5),'#')=0) then
         begin
           lAbsender := hatTextwerkzeug.textOhne(pNachricht,1,5);
           for i:=1 to zAnzUser do
             if Userfeld[i].istAngemeldet then
               self.sendeAnEinen(Userfeld[i].Ip, Userfeld[i].Port,'S'+lAbsender+' hat sich angemeldet.'+ZEILENENDE);
           inc(zAnzUser);
           Userfeld[zAnzUser]:=User.init(pClientIP,pClientPort,lAbsender);
           Userfeld[zAnzUser].anmelden;
           self.sendeAnEinen(pClientIP, pClientPort,'+Hallo, '+lAbsender+', du kannst chatten!'+ZEILENENDE);
         end
         else
           self.sendeAnEinen(pClientIP, pClientPort,'-Username bereits vorhanden oder ungltig oder zu viele User online'+ZEILENENDE);
       end
     else
       self.sendeAnEinen(pClientIP, pClientPort,'-Bitte zuerst anmelden!'+ZEILENENDE);
   end
   else 
   begin
    lAbsender:=Userfeld[self.sucheIpPort(pClientIP,pClientPort)].Username;
    if hatTextwerkzeug.teilZeichenkette(pNachricht,1,4)= 'MSG ' then
    begin
       for i:=1 to zAnzUser do
         if Userfeld[i].istAngemeldet then
           self.sendeAnEinen(Userfeld[i].Ip, Userfeld[i].Port,'*'+lAbsender+'#'+hatTextwerkzeug.textOhne(pNachricht,1,4)+ZEILENENDE);
    end
    else
      if hatTextwerkzeug.teilZeichenkette(pNachricht,1,5)= 'PMSG ' then
       begin
         lEmpfaenger:=hatTextwerkzeug.teilZeichenkette(pNachricht,6,hatTextwerkzeug.positionVon(pNachricht,'#')-1);
         if self.sucheUsername(lEmpfaenger) then
           for i:=1 to zAnzUser do
           begin
             if Userfeld[i].Username = lEmpfaenger then
               self.sendeAnEinen(Userfeld[i].Ip, Userfeld[i].Port,'~'+lAbsender+'#'+hatTextwerkzeug.textOhne(pNachricht,1,5)+ZEILENENDE)
           end
         else self.sendeAnEinen(pClientIP, pClientPort,'-User '+lEmpfaenger+' nicht angemeldet'+ZEILENENDE);
       end
      else
        if hatTextwerkzeug.teilZeichenkette(pNachricht,1,4)= 'LIST' then
          begin
            lUserliste := '$';
            for i :=1 to zAnzUser do
              lUserliste := lUserliste + Userfeld[i].username + '#';
            lUserliste := hatTextwerkzeug.textOhne(lUserliste,hatTextwerkzeug.laenge(lUserliste),hatTextwerkzeug.laenge(lUserliste));  
            self.sendeAnEinen(pClientIp,pClientPort,lUserliste+ZEILENENDE);
          end
        else if hatTextwerkzeug.teilZeichenkette(pNachricht,1,3)= 'BYE' then
          self.loescheUser(pClientIP,pClientPort);
   end
end;

//-------- bearbeiteVerbindungsende (public) ---------------------------
procedure ChatServer.bearbeiteVerbindungsende(pClientIP: Zeichenkette; pClientPort: GanzeZahl);
begin
   self.sendeAnAlle('Der Client mit der IP ' + pClientIP + ' hat die Verbindung abgebrochen.'+ZEILENENDE);
   self.loescheUser(pClientIP,pClientPort);
end;

//-------- bearbeiteVerbindungsverlust (public) ------------------------
procedure ChatServer.bearbeiteVerbindungsverlust(pClientIP: Zeichenkette; pClientPort: GanzeZahl);
begin
   self.sendeAnAlle('Der Client mit der IP ' + pClientIP + ' hat die Verbindung verloren.'+ZEILENENDE);
   self.loescheUser(pClientIP,pClientPort);
end;

//-------- bearbeiteVerbindungsaufbau (public) --------------------------
procedure ChatServer.bearbeiteVerbindungsaufbau (pClientIP: Zeichenkette; pClientPort: GanzeZahl);
begin
   self.sendeAnEinen(pClientIP,'+Willkommen auf unserem Server! Bitte senden sie Ihren Usernamen'+ZEILENENDE);
end;

//--------
function ChatServer.sucheIpPort (pClientIp: Zeichenkette; pClientPort: GanzeZahl) :GanzeZahl;
var
  i : GanzeZahl;
begin
  result := 0;
  for i:=1 to zAnzUser do
    if (Userfeld[i].ip = pClientIP) and (Userfeld[i].port = pClientPort) then
      begin
       result := i;
       break;
      end
end;

//-----------------
function ChatServer.sucheUsername (pUsername : Zeichenkette):Wahrheitswert;
var
  i : GanzeZahl;
begin
  result := FALSCH;
  for i:=1 to zAnzUser do
    if Userfeld[i].Username = pUsername then
    result := WAHR;
end;



//-----------------
procedure ChatServer.loescheUser(pClientIP: Zeichenkette; pClientPort: GanzeZahl);
var
   i  : GanzeZahl;
   lweguser: GanzeZahl;
begin
   lweguser :=  self.sucheIpPort(pClientIp,pClientPort);
   if lweguser <> 0 then
     begin
       userfeld[lweguser].gibfrei;
       for i := lweguser to zAnzUser do
         begin
           Userfeld[i] := Userfeld[i+1];
         end;
       zAnzUser := (zAnzUser-1);
     end;

end;

end.
