{*******************************************************************************
 *                            Binaerbaum Version 1.1                           *
 *                (c) 2003 Klaus Dingemann und Ulrich Borghoff                 *
 *                           eMail: sum-delphi@web.de                          *
 * *****************************************************************************
 * Bitte ndern Sie diese Datei nicht ab, sondern teilen den Entwicklern Ihre  *
 * Verbesserungsvorschlge oder Fehler (und ggf. deren Berichtigung) mit.      *
 *                                                                             *
 * Fr den Unterricht sollten Sie nur die mBinaerbaum.dcu Datei verwenden.     *
 * Diese muss sich im Ordner ..delphi/lib befinden. Die Angabe                 *
 * "uses mBinaerbaum" ist dann schon ausreichend.                              *
 *                                                                             *
 * Danke fr Ihre Mitarbeit.                                                   *
 *******************************************************************************}

unit mBinaerbaum;

interface

  uses mSuM;

  type Binaerbaum = class
    hatInhalt:Basis;
    kenntLinkenNachfolger, kenntRechtenNachfolger:Binaerbaum;
    constructor init;overload;
    constructor init(pInhalt:Basis);overload;
    constructor init(pInhalt:Basis;pLinkerBaum, pRechterBaum:Binaerbaum);overload;
    function neuerLeererBaum:Binaerbaum;virtual; //Muss in Unterklassen berschrieben werden
    procedure ueberschreibeWurzel(pInhalt:Basis);virtual;
    procedure haengeRechtsAn(pBaum:Binaerbaum);
    procedure haengeLinksAn(pBaum:Binaerbaum);
    function wurzelInhalt:Basis; virtual;
    function linkerTeilbaum:Binaerbaum;
    function rechterTeilbaum:Binaerbaum;
    function istLeer:boolean;
    function teilbaeumeLeer:boolean;
    destructor gibFrei(pMitInhalt:boolean);virtual;
  end;

implementation

  constructor Binaerbaum.init;
  begin
    hatInhalt:=nil;
    kenntLinkenNachfolger:=nil;
    kenntRechtenNachfolger:=nil;
  end;

  constructor Binaerbaum.init(pInhalt:Basis);
  begin
    hatInhalt:=pInhalt;
    kenntLinkenNachfolger:=self.neuerLeererBaum;
    kenntRechtenNachfolger:=self.neuerLeererBaum;
  end;

  constructor Binaerbaum.init(pInhalt:Basis;pLinkerBaum, pRechterBaum:Binaerbaum);
  begin
    hatInhalt:=pInhalt;
    kenntLinkenNachfolger:=pLinkerBaum;
    kenntRechtenNachfolger:=pRechterBaum;
  end;

  procedure Binaerbaum.ueberschreibeWurzel(pInhalt:Basis);
  begin
    if hatInhalt=nil then
    begin
      kenntLinkenNachfolger:=self.neuerLeererBaum;
      kenntRechtenNachfolger:=self.neuerLeererBaum;
    end;
    hatInhalt:=pInhalt;
  end;

  function Binaerbaum.neuerLeererBaum:Binaerbaum;
  begin
    result:=Binaerbaum.init;
  end;

  procedure Binaerbaum.haengeRechtsAn(pBaum:Binaerbaum);
  begin
    if not self.istLeer then
      kenntRechtenNachfolger:=pBaum;
  end;

  procedure Binaerbaum.haengeLinksAn(pBaum:Binaerbaum);
  begin
    if not self.istLeer then
       kenntLinkenNachfolger:=pBaum;
  end;

  function Binaerbaum.WurzelInhalt:Basis;
  begin
    result:=hatInhalt;
   end;

  function Binaerbaum.linkerTeilbaum:Binaerbaum;
  begin
    result:=kenntLinkenNachfolger;
  end;

  function Binaerbaum.rechterTeilbaum:Binaerbaum;
  begin
    result:=kenntRechtenNachfolger;
  end;

  function Binaerbaum.istLeer:boolean;
  begin
    result:=hatInhalt=nil;
  end;

  function Binaerbaum.teilbaeumeLeer:boolean;
  begin
    result:=kenntLinkenNachfolger.istLeer and kenntRechtenNachfolger.istLeer;
  end;

  destructor Binaerbaum.gibFrei(pMitInhalt:boolean);
  begin
    if kenntRechtenNachfolger<>nil then kenntRechtenNachfolger.gibFrei(pMitInhalt);
    if kenntLinkenNachfolger<>nil then kenntLinkenNachfolger.gibFrei(pMitInhalt);
    if pMitInhalt and (hatInhalt<>nil) then
      hatInhalt.destroy;
  end;

end.
