{*******************************************************************************
 *  Textdateileser: Datei-Eingabe fr Stifte und Muse                         *
 *               Version 2.0 vom 27.02.2006                                    *
 *               Joachim Deckers, Mariengymnasium Arnsberg                     *
 *               Ursprngliche Fassung: Klaus Dingemann                        *
 *               eMail: sum-delphi@deckers.name                                *
 *******************************************************************************
 * Bitte teilen Sie den Entwicklern Ihre Verbesserungsvorschlge mit oder      *
 * weisen Sie sie auf Fehler (und ggf. deren Berichtigung) hin.                *
 *                                                                             *
 * Danke fr Ihre Mitarbeit.                                                   *
 *******************************************************************************
 * nderungen                                                                  *
 * Version 2.0:                                                                *
 *   - Dateien werden nicht mehr zeichenweise (und dadurch wesentlich          *
 *     schneller!) eingelesen                                                  *
 *   - Datei werden beim Einlesen nicht mehr fr andere Nutzer gesperrt        *
 *******************************************************************************}

unit mTextdateiLeser;
interface
uses SysUtils, mSum;
type
 TextdateiLeser = class
                     hatTextdatei: GanzeZahl; // Filehandle
                     zDateiLaenge: GanzeZahl;
                     zGeoeffnet  : Wahrheitswert;
                     constructor init(pName:Zeichenkette);
                     function lies:Zeichenkette;
                     destructor gibFrei;
                    end;
implementation
   constructor TextdateiLeser.init(pName:Zeichenkette);
   begin
     hatTextdatei := FileOpen(pName,fmOpenRead + fmShareDenyWrite);
     if hatTextdatei >=0 then begin
       zGeoeffnet   := WAHR;
       zDateiLaenge := FileSeek(hatTextdatei,0,2);
       FileSeek(hatTextdatei,0,0);
     end
     else
       zGeoeffnet:= FALSCH;
   end;



   function TextdateiLeser.lies:Zeichenkette;
   var
    lBuffer : PChar;
    lText   : Zeichenkette;
    lGroesse: Zahl;
   begin
     if zGeoeffnet then begin
       GetMem(lBuffer,zDateiLaenge);
       FileRead(hatTextdatei,lBuffer^,zDateiLaenge);
       lText := String(lBuffer);
       FreeMem(lBuffer);
       FileSeek(hatTextdatei,0,0);
     end
     else lText := '';
     result := lText;
   end;


   destructor TextdateiLeser.gibFrei;
   begin
     if zGeoeffnet then
       FileClose(hatTextdatei);
   end;
end.
